#include "Rectangle.hpp"

// default constructor
//Rectangle::Rectangle()
//{
//	mWidth = 0.0;
//	mLength = 0.0;
//}

// our latest version of our constructor uses parameters with default arguments.
// the default arguments should not be placed in the function header, only the
// function declaration.
Rectangle::Rectangle(double newWidth, double newLength)
{
	// validate?
	if (newWidth < 0.0) // we want to make sure that the width is not less than 0; we're validating
	{
		mWidth = 0.0;
	}
	else
	{
		mWidth = newWidth;
	}
	if (newLength < 0.0)
	{
		mLength = 0.0;
	}
	else
	{
		mLength = newLength;
	}
}

// copy constructor - it's called when a copy of a Recangle is made - pass-by-value;
// also called when we instantiate and object and use another object of the same type
// to initialize it.
Rectangle::Rectangle(Rectangle& copy)
{
	//mWidth = copy.getWidth();
	mWidth = copy.mWidth;
	mLength = copy.mLength;
}

// setters - mutators
void Rectangle::setWidth(double newWidth) // the :: here is known as the class scope resolution operator
{                                         // we use the :: to indicate that the function
	                                      // is a specific member of that class
	// we can use setters to validate the parameter that we'll use to set the private
	// data member. we didn't validate the data in this example yet.
	mWidth = newWidth;
}

void Rectangle::setLength(double newLength)
{
	mLength = newLength;
}

// getters - accessors
double Rectangle::getWidth(void)
{
	return mWidth; // returns a copy of the private data to the outside world. the
	               // world that doesn't have direct access to the private data members.
	               // essentially any object or function that is declared outside of the class,
	               // unless keyword friend is used. we'll learn about this later
}

double Rectangle::getLength(void)
{
	return mLength;
}