#pragma once

#include <iostream>

class Rectangle
{

public: // Any function or data member declared inside the public region is "visible"
	    // to any object or function that is declared outside of the this class

	// Any function declared below is considered a member function of class Rectangle.
	// Member functions of a class can directly access the private data members of the
	// class.

	// constructor initializes an object
	//Rectangle(); // default constructor
	//Rectangle(double newWidth, double newLength); // constructor with arguments
	
	// this version of a constructor replaces the need for the other two listed above. however,
	// it doesn't mean we'll always have a constructor with default arguments
	Rectangle(double newWidth = 0.0, double newLength = 0.0); // constructor with default arguments

	// copy constructor - it's called when a copy of a Recangle is made - pass-by-value;
	// also called when we instantiate and object and use another object of the same type
	// to initialize it.
	Rectangle(Rectangle &copy);

	// setters - mutators - allow for outside data to be used
	// to set the private data in the class
	void setWidth(double newWidth);
	void setLength(double newLength);

	// getters - accessors
	double getWidth(void);
	double getLength(void);

private: // Any function or data member declared inside the private region is NOT "visible"
	     // to any object or function that is declared outside of the this class. they're
	     // only visible to members of this class

	// data members - attributes
	double mWidth, 
		   mLength;
};

// function template declaration
template <class T>
T add(T v1, T v2);

// function template definition - these must stay
// in the header file (.h or .hpp)
template <class T>
T add(T v1, T v2)
{
	return v1 + v2;
}